
/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#ifndef SHAPE1_H
#define SHAPE1_H

#include <iostream>

using std::cout;
using std::endl;

#define PI 3.1415926

class Shape {
public:
    virtual double volume() const { return 0.0; };

    //pure virtual functions overriden in derived classes
    virtual double area() const = 0;
    virtual void print() const = 0;
};

#endif


/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#ifndef TWODSHAPE1_H
#define TWODSHAPE1_H

#include "shape1.h"

class TwoDimensionalShape : public Shape {
public:
	TwoDimensionalShape( double = 0.0 , double = 0.0 );
	virtual double area() const { return 0.0; };

protected:
	double x;
	double y;

};

#endif


/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#ifndef THREEDSHAPE1_H
#define THREEDSHAPE1_H

#include "shape1.h"

class ThreeDimensionalShape : public Shape {
public:

    ThreeDimensionalShape ( double = 0.0, double = 0.0, double = 0.0 );
    virtual double area() const { return 0.0; };
    virtual double volume() const { return 0.0; };

    //pure virtual functions overriden in derived classes
	virtual void print() const = 0;

protected:
	double x;
	double y;
	double z;

};

#endif


/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#ifndef CIRCLE1_H
#define CIRCLE1_H


#include "twoDshape1.h"

class Circle :public TwoDimensionalShape {
public:
    Circle ( double = 0.0, double = 0.0, double = 0.0 );

    virtual double area() const;
    virtual void print() const;

private:
    double radius;
};

#endif

/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#include <iostream>

using std::cout;
using std::endl;

#include "circle1.h"

Circle::Circle (double d1, double d2, double d3) : TwoDimensionalShape ( d1, d2)
{
	radius = d3;
}

double Circle::area() const
{
	return PI*radius*radius;
}


void Circle::print() const{
	cout << "Type: Circle  Dimension: 2\n";
}


/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */
#ifndef SQUARE1_H
#define SQUARE1_H

#include "twoDshape1.h"

class Square : public TwoDimensionalShape {
public:
    Square ( double = 0.0, double = 0.0, double = 0.0);

    virtual double area() const;
    virtual void print() const;

private:
    double size; 

};


#endif


/*
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#include <iostream>

using std::cout;
using std::endl;

#include "square1.h"

Square::Square(double d1, double d2, double d3) : TwoDimensionalShape(d1,d2)
{
	size = d3;
}

double Square::area() const 
{
	return size*size;
}

void Square::print() const
{
	cout << "Type: Square  Dimension: 2\n" ;
}


/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#ifndef TRIANGLE1_H
#define TRIANGLE1_H

#include "twoDshape1.h"

class Triangle : public TwoDimensionalShape {
public:
   Triangle (double = 0.0, double = 0.0, double = 0.0, double = 0.0, double =0.0, double =0.0);

    virtual double area() const;
    virtual void print() const;

private:
    double x1;
    double y1;
    double x2;
    double y2;

};

#endif

/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */
#include <iostream>

using std::cout;

#include <cmath>

#include "triangle1.h"

Triangle::Triangle(double d1, double d2, double d3, double d4,
	double d5,double d6):TwoDimensionalShape(d1, d2)
{
	x1 = d3;
	y1 = d4;
	x2 = d5;
	y2 = d6;
}

double Triangle::area() const
{
    double a = sqrt( (x-x1)*(x-x1) + (y-y1)*(y-y1) );
    double b = sqrt( (x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) );
    double c = sqrt( (x2-x)*(x2-x) + (y2-y)*(y2-y) );
    double p = 1.0/2.0 * ( a + b + c );

    return sqrt( p*(p-a)*(p-b)*(p-c) ); 

}

void Triangle::print() const
{
    cout << "Type: Tirangle   Dimension: 2 \n";
}


/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#ifndef SPHERE1_H
#define SPHERE1_H

#include "threeDshape1.h"

class Sphere : public ThreeDimensionalShape{
public:
    Sphere ( double = 0.0, double = 0.0, double = 0.0, double = 0.0 );

    virtual double area() const;
    virtual double volume() const;

    virtual void print() const;

private:
    double radius;
};

#endif

/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#include <iostream>

using std::cout;
using std::endl;

#include "sphere1.h"

#define PI 3.1415926

Sphere::Sphere( double d1, double d2, double d3, double d4 ) 
            : ThreeDimensionalShape(d1,d2,d3)
{
    radius = d4;
}


double Sphere::area() const 
{
    return 4.0*PI*radius*radius;
}

double Sphere::volume() const
{
    return 4.0/3.0*PI*radius*radius*radius;
}

void Sphere::print() const
{
    cout << "Type: Sphere  Dimension 3\n";
}


#ifndef CUBE1_H
#define CUBE1_H

#include "threeDshape1.h"

class Cube : public ThreeDimensionalShape{
public:
   Cube ( double = 0.0, double = 0.0, double = 0.0, double = 0.0 );

   virtual double area() const;
   virtual double volume() const;

   virtual void print() const;

private:
   double size;     //size of cube
};

#endif


/*
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#include <iostream>

using std::cout;
using std::endl;

#include "cube1.h"

Cube::Cube(double d1, double d2, double d3, double d4) 
       : ThreeDimensionalShape(d1,d2,d3)
{
   size = d4;
}

double Cube::area() const
{
   return 6*size*size;
}

double Cube::volume() const
{
    return size*size*size;
}

void Cube::print() const
{
    cout <<"Type: Cube   Dimension: 3\n";
}


/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#ifndef TETRAHEDRON
#define TETRAHEDRON

#include "threeDshape1.h"

class Tetrahedron : public ThreeDimensionalShape {
public:
    Tetrahedron( double=0.0, double=0.0, double=0.0, double=0.0, double=0.0, double=0.0, 
	double=0.0, double=0.0, double=0.0, double=0.0, double=0.0, double=0.0 );
	
    virtual double area() const;
    virtual double volume() const;

    virtual void print() const;

private:
    double x1, y1, z1;
    double x2, y2, z2;
    double x3, y3, z3;
};

#endif

/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#include <iostream>

using std::cout;
using std::endl;

#include <cmath>

#include "tetrahedron1.h"

Tetrahedron::Tetrahedron(double d1, double d2, double d3, double d4, double d5, double d6,
	double d7, double d8, double d9, double d10, double d11, double d12)
	: ThreeDimensionalShape( d1, d2, d3 )
{
	x1 = d4;
	y1 = d5;
	z1 = d6;
	x2 = d7;
	y2 = d8;
	z2 = d9;
	x3 = d10;
	y3 = d11;
	z3 = d12;
}


double Tetrahedron::area() const
{ 
    cout << "Area for Tetrahedron ";

    return 0.0;
}

double Tetrahedron::volume() const
{
    cout <<"Volume for Tetrahedron ";

    return 0.0;
}


void Tetrahedron::print() const
{
    cout << "Type: Tetrahedron   Dimension: 3\n" ;
}


/* 
 * CS 202 HW09 Beiqing Huang
 * Problem 1
 */

#include <iostream>

using std::cout;
using std::endl;

#include "circle1.h"
#include "sphere1.h"
#include "cube1.h"
#include "square1.h"
#include "triangle1.h"
#include "tetrahedron1.h"

void virtualViaPointer( const Shape * );
void virtualViaReference( const Shape & );


int main(){
    
	Circle cl(1.4, 4.0, 5.0);
    Square sq(1.1, 2.2, 6.5);
	Triangle tr(1.0, 2.0, 3.0, 2.0, 3.0, 5.0);
	Sphere sp(1.2, 3.3, 4.5, 6.0);
    Cube cu(3.4, 4.1, 4.2, 3.0);
    Tetrahedron te(1.0, 2.0, 3.1, 4.0, 5.0, 6.2, 7.3, 8.4, 9.8, 10.1, 11.2, 12.0);

    // 2 D
    cl.print();
	cout << cl.area() << endl;
	
	sq.print();
	cout << sq.area() << endl;

	tr.print();
	cout << tr.area() << endl;

	// 3 D
	sp.print();
	cout << sp.area() << endl;
	cout << sp.volume() << endl;
	
    cu.print();
	cout << cu.area() << endl;
	cout << cu.volume() << endl;
	
    te.print();
	cout << te.area() << endl;
	cout << te.volume() << endl;

    Shape *arrayOfShapes[6];

	arrayOfShapes[0] = &cl;
	arrayOfShapes[1] = &sq;
	arrayOfShapes[2] = &tr;
	arrayOfShapes[3] = &sp;
	arrayOfShapes[4] = &cu;
	arrayOfShapes[5] = &te;

	// Via pointer
	for ( int i = 0; i < 6; i++ )
		virtualViaPointer( arrayOfShapes[i] );

	// Via reference
    for ( int j = 0; j < 6; j++ )
		virtualViaReference( *arrayOfShapes[j] );

   
	return 0;

}

void virtualViaPointer( const Shape *baseClassPtr )
{ 
	baseClassPtr->print();
	cout << "\nArea = " << baseClassPtr->area()
		 << "\nVolume = " << baseClassPtr->volume() << "\n\n";
}


void virtualViaReference ( const Shape &baseClassRef )
{
    baseClassRef.print();
	cout << "\nArea = " <<  baseClassRef.area()
		 << "\nVolume = " << baseClassRef.volume() << "\n\n";
}

/*

Type: Circle  Dimension: 2
78.5398
Type: Square  Dimension: 2
42.25
Type: Tirangle   Dimension: 2
3
Type: Sphere  Dimension 3
452.389
904.779
Type: Cube   Dimension: 3
54
27
Type: Tetrahedron   Dimension: 3
Area for Tetrahedron 0
Volume for Tetrahedron 0
Type: Circle  Dimension: 2

Area = 78.5398
Volume = 0

Type: Square  Dimension: 2

Area = 42.25
Volume = 0

Type: Tirangle   Dimension: 2

Area = 3
Volume = 0

Type: Sphere  Dimension 3

Area = 452.389
Volume = 904.779

Type: Cube   Dimension: 3

Area = 54
Volume = 27

Type: Tetrahedron   Dimension: 3
Volume for Tetrahedron Area for Tetrahedron
Area = 0
Volume = 0

Type: Circle  Dimension: 2

Area = 78.5398
Volume = 0

Type: Square  Dimension: 2

Area = 42.25
Volume = 0

Type: Tirangle   Dimension: 2

Area = 3
Volume = 0

Type: Sphere  Dimension 3

Area = 452.389
Volume = 904.779

Type: Cube   Dimension: 3

Area = 54
Volume = 27

Type: Tetrahedron   Dimension: 3
Volume for Tetrahedron Area for Tetrahedron
Area = 0
Volume = 0


*/

